#include "SDL/SDL.h"
#include "SDL/SDL_gfxPrimitives.h"
#include <stdio.h>

#define BASEX 8
#define BASEY (screen->h - 8)

int main(int argc, char **argv)
{
	int factor = 1;
	if (argc > 1) factor = atoi(argv[1]);
	
	SDL_Init(SDL_INIT_VIDEO);
	SDL_Surface *screen = SDL_SetVideoMode(0, 0, 0, SDL_SWSURFACE | SDL_FULLSCREEN);
	
	FILE *f = fopen("kvadrats.dat", "r");
	
	int n, m;
	fscanf(f, "%u%u", &n, &m);
	
	SDL_Event event;
	int x, y, xsrc, ysrc;
	fscanf(f, "%d%d", &xsrc, &ysrc);
	x = xsrc;
	y = ysrc;
	
	for (int i = 1; i < n; ++i)
	{
		int xnew, ynew;
		fscanf(f, "%d%d", &xnew, &ynew);
		
		aalineColor(screen, BASEX + x * factor, BASEY - y * factor, BASEX + xnew * factor, BASEY - ynew * factor, 0xFFFFFFFF);
		SDL_UpdateRect(screen, 0, 0, 0, 0);
		
		while (SDL_PollEvent(&event))
		{
			if (event.type == SDL_QUIT)
			{
				goto quit;
			}
			else if (event.type == SDL_KEYDOWN)
			{
				switch (event.key.keysym.sym)
				{
				case SDLK_F4:
					if (!(event.key.keysym.mod & KMOD_ALT))
					{
						break;
					}
					
					// Fall through
					
				case SDLK_ESCAPE:
					goto quit;
				}
			}
		}
		
		x = xnew;
		y = ynew;
	}
	
	aalineColor(screen, BASEX + x * factor, BASEY - y * factor, BASEX + xsrc * factor, BASEY - ysrc * factor, 0xFFFFFFFF);
	SDL_UpdateRect(screen, 0, 0, 0, 0);
	
	while (SDL_PollEvent(&event))
	{
		if (event.type == SDL_QUIT)
		{
			goto quit;
		}
		else if (event.type == SDL_KEYDOWN)
		{
			switch (event.key.keysym.sym)
			{
			case SDLK_F4:
				if (!(event.key.keysym.mod & KMOD_ALT))
				{
					break;
				}
				
				// Fall through
				
			case SDLK_ESCAPE:
				goto quit;
			}
		}
	}
	
	FILE *fout = fopen("kvadrats.rez", "r");
	
	for (int i = 0; i < m; ++i)
	{
		int xcntr, ycntr;
		fscanf(f, "%d%d", &xcntr, &ycntr);
		
		long long num, den;
		fscanf(fout, "%I64u%I64u", &num, &den);
		if (num % 2) den *= 2;
		else num /= 2;
		
		rectangleColor(screen, BASEX + xcntr * factor - (num * factor + den/2) / den, BASEY - (ycntr * factor - (num * factor + den/2) / den), BASEX + xcntr * factor + (num * factor + den/2) / den, BASEY - (ycntr * factor + (num * factor + den/2) / den), 0xFF0000FF);
		SDL_UpdateRect(screen, 0, 0, 0, 0);
		
		while (SDL_PollEvent(&event))
		{
			if (event.type == SDL_QUIT)
			{
				goto quit;
			}
			else if (event.type == SDL_KEYDOWN)
			{
				switch (event.key.keysym.sym)
				{
				case SDLK_F4:
					if (!(event.key.keysym.mod & KMOD_ALT))
					{
						break;
					}
					
					// Fall through
					
				case SDLK_ESCAPE:
					goto quit;
				}
			}
		}
	}
	
	do
	{
		SDL_WaitEvent(&event);
		
		if (event.type == SDL_KEYDOWN)
		{
			switch (event.key.keysym.sym)
			{
			case SDLK_F4:
				if (!(event.key.keysym.mod & KMOD_ALT))
				{
					break;
				}

				// Fall through

			case SDLK_ESCAPE:
				goto quit;
			}
		}
	}
	while (event.type != SDL_QUIT);
	
quit:
	SDL_Quit();
	return 0;
}
