// Copyright (c) 2010 Oleg Oshmyan <chortos@inbox.lv>

#include <ext/hash_set>
#include <cstdio>
#include <utility>
using namespace std;
using namespace __gnu_cxx;

namespace __gnu_cxx
{
	template<> struct hash<std::pair<long long, long long> >
	{
		size_t operator()(const std::pair<long long, long long> &p) const
		{
			return p.first * 17 + p.second;
		}
	};
}

int main()
{
	FILE *f = fopen("romba.dat", "r");
	
	int n;
	fscanf(f, "%u", &n);
	
	hash_set<pair<long long, long long> > visited;
	enum dir { RIGHT, UP, LEFT, DOWN } dir = RIGHT;
	long long x = 0, y = 0;
	
	while (n--)
	{
		char c;
		fscanf(f, " %c", &c);
		
		if (c == 'T')
		{
			int len;
			fscanf(f, "%u", &len);
			
			switch (dir)
			{
			case RIGHT:
				for (long long i = x + 1; i <= x + len; ++i)
				{
					visited.insert(make_pair(i, y));
				}
				x += len;
				break;
				
			case UP:
				for (long long i = y + 1; i <= y + len; ++i)
				{
					visited.insert(make_pair(x, i));
				}
				y += len;
				break;
				
			case LEFT:
				for (long long i = x - 1; i >= x - len; --i)
				{
					visited.insert(make_pair(i, y));
				}
				x -= len;
				break;
				
			case DOWN:
				for (long long i = y - 1; i >= y - len; --i)
				{
					visited.insert(make_pair(x, i));
				}
				y -= len;
				break;
			}
		}
		else if (c == 'K')
		{
			dir = (enum dir) ((dir + 1) % 4);
		}
		else
		{
			dir = (enum dir) ((dir + 3) % 4);
		}
	}
	
	freopen("romba.rez", "w", f);
	fprintf(f, "%u\n", visited.size());
	fclose(f);
	return 0;
}
