#include "SDL/SDL.h"
#include "SDL/SDL_gfxPrimitives.h"
#include <stdio.h>

int main(void)
{
	SDL_Init(SDL_INIT_VIDEO);
	SDL_Surface *screen = SDL_SetVideoMode(0, 0, 0, SDL_SWSURFACE | SDL_FULLSCREEN);
	
	FILE *f = fopen("romba.dat", "r");
	
	int n;
	fscanf(f, "%u", &n);
	
	enum dir { RIGHT, UP, LEFT, DOWN } dir = RIGHT;
	long long x = 0, y = 0;
	
	_Bool delay = 1;
	SDL_Event event;
	
	for (int i = 0; i < n; ++i)
	{
		char c;
		fscanf(f, " %c", &c);
		
		if (c == 'T')
		{
			int len;
			fscanf(f, "%u", &len);
			
			switch (dir)
			{
			case RIGHT:
				//boxColor(screen, screen->w/2 + (x+1)*32 - 16, screen->h/2 - y*32 - 16, screen->w/2 + (x+len)*32 + 15, screen->h/2 - y*32 + 15, 0x00FF00FF);
				hlineColor(screen, screen->w/2 + x+1, screen->w/2 + x+len, screen->h/2 + y, 0x00FF00FF);
				x += len;
				break;
				
			case UP:
				//boxColor(screen, screen->w/2 + x*32 - 16, screen->h/2 - (y+len)*32 - 16, screen->w/2 + x*32 + 15, screen->h/2 - (y+1)*32 + 15, 0x00FF00FF);
				vlineColor(screen, screen->w/2 + x, screen->h/2 - (y+len), screen->h/2 - (y+1), 0x00FF00FF);
				y += len;
				break;
				
			case LEFT:
				//boxColor(screen, screen->w/2 + (x-len)*32 - 16, screen->h/2 - y*32 - 16, screen->w/2 + (x-1)*32 + 15, screen->h/2 - y*32 + 15, 0x00FF00FF);
				hlineColor(screen, screen->w/2 + x-len, screen->w/2 + x-1, screen->h/2 - y, 0x00FF00FF);
				x -= len;
				break;
				
			case DOWN:
				//boxColor(screen, screen->w/2 + x*32 - 16, screen->h/2 - (y-1)*32 - 16, screen->w/2 + x*32 + 15, screen->h/2 - (y-len)*32 + 15, 0x00FF00FF);
				vlineColor(screen, screen->w/2 + x, screen->h/2 - (y-1), screen->h/2 - (y-len), 0x00FF00FF);
				y -= len;
				break;
			}
			
			SDL_UpdateRect(screen, 0, 0, 0, 0);
			if (delay) SDL_Delay(500);
			
			while (SDL_PollEvent(&event))
			{
				if (event.type == SDL_QUIT)
				{
					goto quit;
				}
				else if (event.type == SDL_KEYDOWN)
				{
					switch (event.key.keysym.sym)
					{
					case SDLK_F4:
						if (!(event.key.keysym.mod & KMOD_ALT))
						{
							break;
						}
						
						// Fall through
						
					case SDLK_ESCAPE:
						goto quit;
						
					case SDLK_SPACE:
						delay = 0;
					}
				}
			}
		}
		else if (c == 'K')
		{
			dir = (enum dir) ((dir + 1) % 4);
		}
		else
		{
			dir = (enum dir) ((dir + 3) % 4);
		}
	}
	
	SDL_UpdateRect(screen, 0, 0, 0, 0);
	
	do
	{
		SDL_WaitEvent(&event);
		
		if (event.type == SDL_KEYDOWN)
		{
			switch (event.key.keysym.sym)
			{
			case SDLK_F4:
				if (!(event.key.keysym.mod & KMOD_ALT))
				{
					break;
				}

				// Fall through

			case SDLK_ESCAPE:
				goto quit;
			}
		}
	}
	while (event.type != SDL_QUIT);
	
quit:
	SDL_Quit();
	return 0;
}
